
//+------------------------------------------------------------------+
//|                                                FXCorrelator.mq4  |
//|                                                Copyright  2009, |
//|                                                                  |
//+------------------------------------------------------------------+
/*
Meet the family

Sterling (Red)
Volatile little varmit, mainly hates (ie negative correlation) the Yen and USD$
Not absolute friends (ie positive Correlation) with anything else (in my humble opinion)
perhaps is more friendly and runs with the European Currencies than anything else  but
much more Volatile so dont get bitten !
Non Forex-wise any relationships it has are probably due to its negative
correlation to the USD$ and the Yen  so refer below to those comments

Euro (Blue)
Lower volatility than most again I would say, primarily hates (ie negative correlation)
the Yen and USD$. Its best chum (ie positive Correlation) is the Swissie and they go most
places together in my opinion.
Non Forex-wise any relationships it has probably relate more to its Negative correlation
to the USD$ and the Yen  so refer below to those

SwissFranc(Grey)
All said above in the Euro comments Swissie (in my opinion) demonstrates lowest volatility
levels of all the Majors most of the timeuseful for trading against higher volatility currencies

AUS$ (Gold)
Gday mate.It cant stand the USD$ and the Yen, and should party a lot with its neighbours (NZ$)
but seemingly not enough as you would trade reliably on  loves to party hard with high interest
rates on offer compared to the other Majors.
Non Forex-wise .loves Gold (positive correlations) but enough to trade reliably on (?)

NZ$(Lightblue)
Same relationships as its neighbour above..is also fond of high interest rates.

YEN (Yellow)
Volatile and mainly hates all currencies (ie negative correlations) except the
USD$, which generally moves in the same direction (but US$ is generally less volatile). People sell
it in perceived times of greater risk/opportunity as it has the lowest interest rates out there....
then they can buy high Yielders (AUS$ and NZ$)
Non Forex-wise It hates (negative correlation) most Stock indices and Commodities. Traders sell
Yen (the carry trade) to buy these (and Vice versa).watch it against the US Stock Indices for
closest (negative) correlations


CAD$ (Brown)
Difficult to pin this one down - except moves generally negative to US$ and Yen
Non Forex-wise .loves Crudeoil (positive correlation) but enough to trade reliably on (?)

USD$ (Green)
The Daddy whether the rest of the unruly forex family like it or not !.

Hates all currencies (ie negative correlations) except the Yen , which generally moves in the same
direction (but the US$ is generally less volatile). People sell it in perceived times of greater
risk/opportunity (its the major holding reserve currency for most countries) Counter-wise traders
will buy it as a safe haven when they are dumping everything else and risk appetites are falling
commonly dumping the high Yielders (AUS$ and NZ$)
Non Forex-wise It hates (negative correlation) most Stock indices and Commodities. Watch it against
Gold especially for some great (negative) correlation Plays .

*/
#property copyright "FXCorrelator"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Orange
#property indicator_color4 Gray
#property indicator_color5 Yellow
#property indicator_color6 Turquoise
#property indicator_color7 Brown
#property indicator_color8 Lime
#property indicator_level1 0.0

//
//
//
//
//

extern string _            = "Parameters";
extern int    Price        = 0;
extern double PerAvr       = 100;
extern double Phase        = 0;
extern bool   SmoothDouble = true;
extern bool   ShowEUR      = true;
extern bool   ShowGBP      = true;
extern bool   ShowAUD      = true;
extern bool   ShowCHF      = true;
extern bool   ShowJPY      = true;
extern bool   ShowNZD      = true;
extern bool   ShowCAD      = true;
extern bool   ShowUSD      = true;
extern string SymbolSuffix = "";
extern int    Delta        = 1;

//
//
//
//
//

double Idx[];
double Idx1[];
double Idx2[];
double Idx3[];
double Idx4[];
double Idx5[];
double Idx6[];
double Idx7[];

//
//
//
//
//

string ShortName;
string Currencies[]    = { "EUR","GBP","AUD","CHF","JPY","NZD","CAD","USD" };
int    Colors[]        = { indicator_color1, indicator_color2, indicator_color3, indicator_color4,
                           indicator_color5, indicator_color6, indicator_color7, indicator_color8 };

string indicatorFileName;
bool returnBars;
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
  {
  
   for ( int i = 0; i < 8; i++ )
   {
      SetIndexStyle(i,DRAW_LINE,STYLE_SOLID,1);
      SetIndexLabel(i,Currencies[i]);
   }
   
   //
   //
   //
   //
   //
   
   SetIndexBuffer(0,Idx);
   SetIndexBuffer(1,Idx1);
   SetIndexBuffer(2,Idx2);
   SetIndexBuffer(3,Idx3);
   SetIndexBuffer(4,Idx4);
   SetIndexBuffer(5,Idx5);
   SetIndexBuffer(6,Idx6);
   SetIndexBuffer(7,Idx7);
         indicatorFileName = WindowExpertName();
         returnBars        = (_=="returnBars");  if (returnBars) return(0);
   
   //
   //
   //
   //
   //
   
   ShortName = "FXCORR ("+DoubleToStr(PerAvr,2)+","+DoubleToStr(Delta,2)+")";
   
   IndicatorShortName(ShortName);
   
   return(0);
  }
  
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int deinit()
{
   for(int i = 0; i < 8; i++) ObjectDelete("obj_"+Currencies[i]);
   return(0);
}
string symbols[];
void addSymbol(string symbol)
{
   ArrayResize(symbols,ArraySize(symbols)+1); symbols[ArraySize(symbols)-1] = symbol+SymbolSuffix;
}
int getLimit(int limit, string symbol)
{
   if (symbol!=Symbol())
          limit = MathMax(MathMin(Bars-1,iCustom(symbol,0,indicatorFileName,"returnBars",0,0)),limit);
   return(limit);
}

//
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{ 
   static bool ObjectsCreated  = false;
          if (!ObjectsCreated)
          {
              CreateObjects();
              ObjectsCreated = true;
          }
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Idx[0] = limit; return(0); }
         for (int t=0; t<ArraySize(symbols); t++) limit = getLimit(limit,symbols[t]);
   
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)   
   {
   
    double A1 =(iDSmooth(iMA("EURUSD"+SymbolSuffix,0,1,0,MODE_SMA,Price,i),PerAvr,Phase,SmoothDouble,i, 0) - iDSmooth(iMA("EURUSD"+SymbolSuffix,0,1,0,MODE_SMA,Price,i+Delta),PerAvr,Phase,SmoothDouble,i+Delta,  20))/1;
    double A2 =(iDSmooth(iMA("GBPUSD"+SymbolSuffix,0,1,0,MODE_SMA,Price,i),PerAvr,Phase,SmoothDouble,i,40) - iDSmooth(iMA("GBPUSD"+SymbolSuffix,0,1,0,MODE_SMA,Price,i+Delta),PerAvr,Phase,SmoothDouble,i+Delta,  60))/1; 
    double A3 =(iDSmooth(iMA("AUDUSD"+SymbolSuffix,0,1,0,MODE_SMA,Price,i),PerAvr,Phase,SmoothDouble,i,80) - iDSmooth(iMA("AUDUSD"+SymbolSuffix,0,1,0,MODE_SMA,Price,i+Delta),PerAvr,Phase,SmoothDouble,i+Delta, 100))/1;
    double A4 =(iDSmooth(iMA("USDCHF"+SymbolSuffix,0,1,0,MODE_SMA,Price,i+Delta),PerAvr,Phase,SmoothDouble,i+Delta,120) - iDSmooth(iMA("USDCHF"+SymbolSuffix,0,1,0,MODE_SMA,Price,i),PerAvr,Phase,SmoothDouble,i,140))/1;
    double A5 =(iDSmooth(iMA("USDJPY"+SymbolSuffix,0,1,0,MODE_SMA,Price,i+Delta),PerAvr,Phase,SmoothDouble,i+Delta,160) - iDSmooth(iMA("USDJPY"+SymbolSuffix,0,1,0,MODE_SMA,Price,i),PerAvr,Phase,SmoothDouble,i,180))/100; 
    double A6 =(iDSmooth(iMA("NZDUSD"+SymbolSuffix,0,1,0,MODE_SMA,Price,i),PerAvr,Phase,SmoothDouble,i,200) - iDSmooth(iMA("NZDUSD"+SymbolSuffix,0,1,0,MODE_SMA,Price,i+Delta),PerAvr,Phase,SmoothDouble,i+Delta,220))/1;  
    double A7 =(iDSmooth(iMA("USDCAD"+SymbolSuffix,0,1,0,MODE_SMA,Price,i+Delta),PerAvr,Phase,SmoothDouble,i+Delta,240) - iDSmooth(iMA("USDCAD"+SymbolSuffix,0,1,0,MODE_SMA,Price,i),PerAvr,Phase,SmoothDouble,i,260))/1;
    
    //
    //
    //
    //
    //
      
    double USD = -(A1+A2+A3+A4+A5+A6+A7)/7;
    double EUR = A1 -(A2+A3+A4+A5+A6+A7)/6;
    double GBP = A2 -(A1+A3+A4+A5+A6+A7)/6;
    double AUD = A3 -(A1+A2+A4+A5+A6+A7)/6;     
    double CHF = A4 -(A1+A2+A3+A5+A6+A7)/6;  
    double JPY = A5 -(A1+A2+A3+A4+A6+A7)/6;
    double NZD = A6 -(A1+A2+A3+A4+A5+A7)/6;
    double CAD = A7 -(A1+A2+A3+A4+A5+A6)/6;
    
    //
    //
    //
    //
    //
             
    if (ShowEUR) Idx[i]  = EUR;
    if (ShowGBP) Idx1[i] = GBP;
    if (ShowAUD) Idx2[i] = AUD;
    if (ShowCHF) Idx3[i] = CHF;
    if (ShowJPY) Idx4[i] = JPY;
    if (ShowNZD) Idx5[i] = NZD;
    if (ShowCAD) Idx6[i] = CAD;
    if (ShowUSD) Idx7[i] = USD;
   }
 
   return(0);
}
  
//+------------------------------------------------------------------+ 
//
//
//
//

double wrk[][280];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//
//
//
//
//

void CreateObject(string currency, int window, int x, int y, int col)
{
   int ret = ObjectCreate("obj_"+currency,OBJ_LABEL,window,0,0);
             ObjectSetText("obj_"+currency,currency,8);
                 ObjectSet("obj_"+currency,OBJPROP_COLOR,col);
                 ObjectSet("obj_"+currency,OBJPROP_XDISTANCE,x);
                 ObjectSet("obj_"+currency,OBJPROP_YDISTANCE,y);
}

//
//
//
//
//

void CreateObjects()
{
   int xStart = 4;
   int xIncrement = 25;
   
   int yStart = 16;
   int yIncrement = 0;
   
   int window = WindowFind(ShortName);

   for(int i = 0; i < 8; i++ )
   {
      if (ShowUSD && Currencies[i]=="USD") { CreateObject(Currencies[i], window, xStart, yStart, Colors[i]);                      }
      if (ShowEUR && Currencies[i]=="EUR") { CreateObject(Currencies[i], window, xStart, yStart, Colors[i]); addSymbol("EURUSD"); }
      if (ShowGBP && Currencies[i]=="GBP") { CreateObject(Currencies[i], window, xStart, yStart, Colors[i]); addSymbol("GBPUSD"); }
      if (ShowCHF && Currencies[i]=="CHF") { CreateObject(Currencies[i], window, xStart, yStart, Colors[i]); addSymbol("USDCHF"); }
      if (ShowJPY && Currencies[i]=="JPY") { CreateObject(Currencies[i], window, xStart, yStart, Colors[i]); addSymbol("USDJPY"); }
      if (ShowAUD && Currencies[i]=="AUD") { CreateObject(Currencies[i], window, xStart, yStart, Colors[i]); addSymbol("AUDUSD"); }
      if (ShowCAD && Currencies[i]=="CAD") { CreateObject(Currencies[i], window, xStart, yStart, Colors[i]); addSymbol("USDCAD"); }
      if (ShowNZD && Currencies[i]=="NZD") { CreateObject(Currencies[i], window, xStart, yStart, Colors[i]); addSymbol("NZDUSD"); }
      xStart += xIncrement;
      yStart += yIncrement;
   }
}


